// 
//

#include "stdafx.h"
#include "..\common\WebUtil.h"
#define PL_TIME MAKELONG( CEVT_FILETIME, 0x0 )
#define PL_ITEM	MAKELONG( CEVT_BLOB, 0x1 )

// ----------------------------------------------------------------------------
// G[\
// ----------------------------------------------------------------------------
void Error(MyVarMem* pRes, char* pszErrorString)
{
	pRes->Clear();
	pRes->Add("Content-Type: text/html\r\n\r\n");
	pRes->Add("<HTML><BODY>");
	pRes->Add(pszErrorString);
	pRes->Add("</BODY></HTML>");
}

// ----------------------------------------------------------------------------
// HTML wb_[o
// ----------------------------------------------------------------------------
void HTML_HEADER( MyHash* pEnv, MyVarMem* pRes )
{
	pRes->Add( 
		"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=shift_jis\">\n"
		"<HTML><HEAD>\n"
		"<TITLE>CEHTTP BBS</TITLE>\n"
		"</HEAD>\n"
		"<BODY>\n");

	return;
}

// ----------------------------------------------------------------------------
// HTML tb^[o
// ----------------------------------------------------------------------------
void HTML_FOOTER( MyHash* pEnv, MyVarMem* pRes )
{
	pRes->Add(
		"<HR><A HREF=\"http://www001.upp.so-net.ne.jp/ishi/\">CEHTTP BBS by IshiSoft</A>"
		"</BODY></HTML>\n");
}

void EnumDbase( WebUtil* pwu )
{
	MyHash* pEnv = pwu->GetEnv();
	MyVarMem* pBody	= pwu->GetBody();
	MyVarMem* pRes = pwu->GetRes();
	HANDLE hEnum;
	CEOID db;
	CEOIDINFO obj;
	DWORD      dwErr;

	char	szFmt[512];

	char* p;

	if( (hEnum = CeFindFirstDatabase(0)) != INVALID_HANDLE_VALUE)
	{
		pRes->Add(
			"<table cellspacing=\"0\">\n"
			"<tr bgcolor=\"#CCFFCC\">\n"
			"<td>Database name</td>\n"
			"<td align=\"right\">size</td>\n"
			"<td align=\"right\">records</td>\n"
			"<td align=\"right\">oid</td>\n"
			"<td align=\"right\">wNumSortOrder</td>\n"
			"<td align=\"right\">command</td>\n"
			"</tr>\n" );
		while( (db = CeFindNextDatabase(hEnum)) != 0)
		{
			if ( !CeOidGetInfo(db, &obj) )
			{
				sprintf(szFmt, "CeOidGetInfo failed with error (%ld)", GetLastError());
				pRes->Add(szFmt);
				break;
			}
			else
			{
				p = WStrToStrAlloc(obj.infDatabase.szDbaseName);
				
				if( p != NULL )
				{
					if( strncmp(p, "CEHTTP_", 7) == 0 )
					{
						sprintf(szFmt, 
							" <tr bgcolor=\"#CCCCFF\">\n"
							"  <td>%s@</td>\n"
							"  <td align=\"right\">@%d</td>\n"
							"  <td align=\"right\">@%d</td>\n"
							"  <td align=\"right\">@%#X</td>\n"
							"  <td align=\"right\">@%d</td>\n"
							"  <td><a href=\"%s?cmd=delete&db=%d\">DELETE DB</a></td>\n"
							" </tr>\n"
							
							, p
							, obj.infDatabase.dwSize
							, obj.infDatabase.wNumRecords
							, db
							, obj.infDatabase.wNumSortOrder
							, pEnv->GetValue("SCRIPT_NAME"), db
							);

						pRes->Add(szFmt);
					}
					else
					{
						sprintf(szFmt, 
							" <tr bgcolor=\"#FFFFFF\">\n"
							"  <td>%s</td>\n"
							"  <td align=\"right\">%d</td>\n"
							"  <td align=\"right\">%d</td>\n"
							"  <td align=\"right\">%#X</td>\n"
							"  <td align=\"right\">@%d</td>\n"
							" </tr>\n"
							, p
							, obj.infDatabase.dwSize
							, obj.infDatabase.wNumRecords
							, db
							, obj.infDatabase.wNumSortOrder
							);

						pRes->Add(szFmt);
					}
					free( p );
				}


			}

		}
		pRes->Add("</table>\n");

		if ( (dwErr = GetLastError()) != ERROR_NO_MORE_ITEMS )
		{
			sprintf(szFmt, "CeFindFirstDatabase failed with error (%ld)\n", dwErr);
			pRes->Add(szFmt);
		}

	}
	else
	{
		sprintf(szFmt, "CeFindFirstDatabase failed with error (%ld)\n", GetLastError());
		pRes->Add(szFmt);
	}
}

void DeleteDB( WebUtil* pwu )
{
	MyVarMem* pRes = pwu->GetRes();

	CEGUID ceguid;
	CEOID CeOid;
	CEOIDINFO obj;
	CREATE_SYSTEMGUID( &ceguid );

	CeOid = (CEOID)pwu->GetItemInt("db=");

	if ( !CeOidGetInfo(CeOid, &obj) )
	{
		Error(pRes, "CeOidGetInfo failed with error.");
		return;
	}

	if( obj.wObjType != OBJTYPE_DATABASE )
	{
		Error(pRes, "This oid is not database type.");
		return;
	}

	char* p = WStrToStrAlloc(obj.infDatabase.szDbaseName);
	
	if( p == NULL )
	{
		Error(pRes, "Memory alloc failed.");
		return;
	}

	if( strncmp(p, "CEHTTP_", 7) == 0 )
	{
		if( CeDeleteDatabase(CeOid) )
		{
			Error(pRes, "Database deleted.");
		}
		else
		{
			Error(pRes, "Database failed.");
		}
	}
	else
	{
		Error(pRes, "This is not CEHTTP family.");
	}
	free(p);
}

//*****************************************************************************
//
// fhChx
//	@etail
//		CGI[gDoc[gzɂ邱ƂKvƂȂ܂
//		Ƃ ../<cgiroot>/cgi.cgiȂǂ͔F܂
//		Ăяoɂ..͎gȂ
//
//		ԓ͕KCRLFŉs܂B
//		sڂ́uContent-Type: vLqĂB
//
// ----------------------------------------------------------------------------
//
//	@param
//		MyHash*		pEnv		ϐ܂
//		MyVarMem*	pBody		POSTꂽꍇANGXg{fB܂
//		MyVarMem*	pRes		NCAgɕԂeǉ܂
//
//	@return
//		pResɋlߍ񂾃oCgԂĂB
//
//*****************************************************************************
int fnChx(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes)
{
	WebUtil	wu(pEnv, pBody, pRes);

	pRes->Clear();
	pRes->Add( "Content-Type: text/html; Charset=Shift_JIS\r\n\r\n" );
	char	szCommand[10];
	

	wu.GetItem("cmd=", szCommand, 9);
	
	if( STRICMP( szCommand, "Delete" ) == 0 )
	{
		DeleteDB( &wu );
	}
	else
	{
		EnumDbase( &wu );
	}

	HTML_FOOTER( pEnv, pRes );

	return pRes->GetLength();
}

//*****************************************************************************
//
// DllMain
//
//*****************************************************************************
BOOL APIENTRY DllMain(
	HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}
